#
# Copyright (c) 2014
#  Adam Tauno Williams <awilliam@whitemice.org>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

COILS_TIMEZONES = [
    {'abbreviation': 'GMT+0500',
     'description': 'GMT+5',
     'code': 'Etc/GMT+5'},
    {'abbreviation': 'GMT+1200',
     'description': 'GMT+12',
     'code': 'Etc/GMT+12'},
    {'abbreviation': 'MET',
     'description': 'Poland',
     'code': 'MET'},
    {'abbreviation': 'GMT-0300',
     'description': 'GMT-3',
     'code': 'Etc/GMT-3'},
    {'abbreviation': 'CST',
     'description': 'US/Central',
     'code': 'US/Central'},
    {'abbreviation': 'GMT-0500',
     'description': 'GMT-5',
     'code': 'Etc/GMT-5'},
    {'abbreviation': 'HST',
     'description': 'US/Hawaii',
     'code': 'US/Hawaii'},
    {'abbreviation': 'GMT-1200',
     'description': 'GMT-12',
     'code': 'Etc/GMT-12'},
    {'abbreviation': 'MST',
     'description': 'US/Mountain',
     'code': 'US/Mountain'},
    {'abbreviation': 'SST',
     'description': 'Singapore',
     'code': 'Singapore'},
    {'abbreviation': 'GMT+0700',
     'description': 'GMT+7',
     'code': 'Etc/GMT+7'},
    {'abbreviation': 'NZDT',
     'description': 'NZ',
     'code': 'NZ'},
    {'abbreviation': 'PST',
     'description': 'US/Pacific',
     'code': 'US/Pacific'},
    {'abbreviation': 'EST',
     'description': 'US/Eastern',
     'code': 'EST'},
    {'abbreviation': 'GMT-0700',
     'description': 'GMT-7',
     'code': 'Etc/GMT-7'},
    {'abbreviation': 'GMT+0200',
     'description': 'GMT+2',
     'code': 'Etc/GMT+2'},
    {'abbreviation': 'GMT+1100',
     'description': 'GMT+11',
     'code': 'Etc/GMT+11'},
    {'abbreviation': 'GMT-0200',
     'description': 'GMT-2',
     'code': 'Etc/GMT-2'},
    {'abbreviation': 'GMT-1100',
     'description': 'GMT-11',
     'code': 'Etc/GMT-11'},
    {'abbreviation': 'EET',
     'description': 'Turkey',
     'code': 'Turkey'},
    {'abbreviation': 'GMT',
     'description': 'GMT',
     'code': 'GMT'},
    {'abbreviation': 'GMT+0400',
     'description': 'GMT+4',
     'code': 'Etc/GMT-4'},
    {'abbreviation': 'JST',
     'description': 'Japan',
     'code': 'Japan'},
    {'abbreviation': 'GMT+0100',
     'description': 'GMT+1',
     'code': 'Etc/GMT+1'},
    {'abbreviation': 'GMT-1000',
     'description': 'GMT-10',
     'code': 'Etc/GMT-10'},
    {'abbreviation': 'GMT+0800',
     'description': 'GMT+8',
     'code': 'Etc/GMT+8'},
    {'abbreviation': 'GMT-0100',
     'description': 'GMT-1',
     'code': 'Etc/GMT-1'},
    {'abbreviation': 'GMT-0800',
     'description': 'GMT-8',
     'code': 'Etc/GMT-8'},
    {'abbreviation': 'GMT+0300',
     'description': 'GMT+3',
     'code': 'Etc/GMT+3'},
    {'abbreviation': 'GMT',
     'description': 'GMT',
     'code': 'UTC'},
]
