#
# Copyright (c) 2011 Adam Tauno Williams <awilliam@whitemice.org>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#
from sqlalchemy         import *
from coils.core         import *
from command            import AttachmentCommand

class GetAttachmentHandle(Command, AttachmentCommand):
    __domain__ = "attachment"
    __operation__ = "get-handle"

    def __init__(self):
        Command.__init__(self)

    def parse_parameters(self, **params):
        # TODO: Support opening message via label & process
        Command.parse_parameters(self, **params)
        self.attachment = params.get('attachment', None)
        if (self.attachment is None):
            if ('uuid' in params):
                self.attachment = self._ctx.run_command('attachment::get', uuid=params.get('uuid'))
        if (self.attachment is None):
            raise CoilsException('No attachment or UUID provided to message::get-text')

    def run(self):
        self._result = BLOBManager.Open(self.attachment_text_path(self.attachment), 'rb', encoding='binary')
