#
# Copyright (c) 2010, 2011, 2013, 2015, 2018
#  Adam Tauno Williams <awilliam@whitemice.org>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

from foundation import \
    PathObject, \
    DAVObject, \
    DAVFolder, \
    EmptyFolder, \
    OmphalosCollection, \
    OmphalosObject, \
    RSSFeed, \
    LogObject, \
    StaticObject, \
    Parser, \
    BufferedWriter, \
    CachedData, \
    Multistatus_Response, \
    json_encode, \
    yaml_encode, \
    UserAgent, \
    ObjectPropertyPOST
from protocol import Protocol
from root import RootFolder
from http_handler import CoilsRequestHandler
from http_server import CoilsHTTPServer
from http_service import HTTPService
from xmlrpc import XMLRPCServer
from zogi import ZOGIAPI
from smtp_service import SMTPService
from smtp_common import \
    get_streams_from_message as get_streams_from_smtp_message
